
#include <stdio.h>
#include <stdlib.h>
#include <glib.h>
#include <glib-object.h>

#include "btctl.h"

static void status_callback(Btctl *bc,
        gint    field,
        gpointer data) {

    printf("got status %d\n", field);
}

static void add_device_callback(Btctl *bc,
        gchar*    name,
        gpointer data) {

    printf("got device %s\n", name);
}

static void device_name_callback(Btctl *bc,
        gchar*   device,
        gchar*   name,
        gpointer data) {

    printf("device %s is called %s\n", device, name);
}

static void add_device_service_callback(Btctl *bc,
                            gchar *addr, gchar *name, 
                            guint clsid, guint channel,
										gpointer data)
{
    printf("device %s (%s) has service %d channel %d\n",
                addr, name, clsid, channel);
}


int main(int argc, char **argv)
{
    Btctl *bc;
    g_type_init();

    bc=BTCTL(btctl_new());
    g_signal_connect (G_OBJECT(bc), "status_change",
                G_CALLBACK(status_callback), NULL);
    g_signal_connect (G_OBJECT(bc), "add_device",
                G_CALLBACK(add_device_callback), NULL);
    g_signal_connect (G_OBJECT(bc), "device_name",
                G_CALLBACK(device_name_callback), NULL);
    g_signal_connect (G_OBJECT(bc), "add_device_service",
                G_CALLBACK(add_device_service_callback),
                NULL);

	printf("Try to get channel 1 of 00:80:37:2A:B6:BC ==> %d\n", 
		   btctl_establish_rfcomm_connection(bc, "00:80:37:2A:B6:BC", 1));

	btctl_list_rfcomm_connections(bc);

	printf("Connection to 00:80:37:2A:B6:BC %d\n", 
		   btctl_get_established_rfcomm_connection(bc, "00:80:37:2A:B6:BC", 0));

    btctl_discover_devices(bc);
    
    g_object_unref(bc);
    return 0;
}
